##// END OF EJS Templates
enble to add graphics acceleration for Pi4
vidal -
r758:cbd6423e90b0
parent child
Show More
@@ -1,323 +1,334
1 1 #
2 2 # Setup RPi2/3/4 config and cmdline
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 if [ -n "$RPI_FIRMWARE_DIR" ] && [ -d "$RPI_FIRMWARE_DIR" ] ; then
9 9 # Install boot binaries from local directory
10 10 cp "${RPI_FIRMWARE_DIR}"/boot/bootcode.bin "${BOOT_DIR}"/bootcode.bin
11 11 cp "${RPI_FIRMWARE_DIR}"/boot/fixup.dat "${BOOT_DIR}"/fixup.dat
12 12 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_cd.dat "${BOOT_DIR}"/fixup_cd.dat
13 13 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_x.dat "${BOOT_DIR}"/fixup_x.dat
14 14 cp "${RPI_FIRMWARE_DIR}"/boot/start.elf "${BOOT_DIR}"/start.elf
15 15 cp "${RPI_FIRMWARE_DIR}"/boot/start_cd.elf "${BOOT_DIR}"/start_cd.elf
16 16 cp "${RPI_FIRMWARE_DIR}"/boot/start_x.elf "${BOOT_DIR}"/start_x.elf
17 17 cp "${RPI_FIRMWARE_DIR}"/boot/fixup4cd.dat "${BOOT_DIR}"/fixup4cd.dat
18 18 cp "${RPI_FIRMWARE_DIR}"/boot/fixup4.dat "${BOOT_DIR}"/fixup4.dat
19 19 cp "${RPI_FIRMWARE_DIR}"/boot/fixup4db.dat "${BOOT_DIR}"/fixup4db.dat
20 20 cp "${RPI_FIRMWARE_DIR}"/boot/fixup4x.dat "${BOOT_DIR}"/fixup4x.dat
21 21 cp "${RPI_FIRMWARE_DIR}"/boot/start4cd.elf "${BOOT_DIR}"/start4cd.elf
22 22 cp "${RPI_FIRMWARE_DIR}"/boot/start4db.elf "${BOOT_DIR}"/start4db.elf
23 23 cp "${RPI_FIRMWARE_DIR}"/boot/start4.elf "${BOOT_DIR}"/start4.elf
24 24 cp "${RPI_FIRMWARE_DIR}"/boot/start4x.elf "${BOOT_DIR}"/start4x.elf
25 25 else
26 26 # Create temporary directory for boot binaries
27 27 temp_dir=$(as_nobody mktemp -d)
28 28
29 29 # Install latest boot binaries from raspberry/firmware github
30 30 as_nobody wget -q -O "${temp_dir}/bootcode.bin" "${FIRMWARE_URL}/bootcode.bin"
31 31 as_nobody wget -q -O "${temp_dir}/fixup.dat" "${FIRMWARE_URL}/fixup.dat"
32 32 as_nobody wget -q -O "${temp_dir}/fixup_cd.dat" "${FIRMWARE_URL}/fixup_cd.dat"
33 33 as_nobody wget -q -O "${temp_dir}/fixup_x.dat" "${FIRMWARE_URL}/fixup_x.dat"
34 34 as_nobody wget -q -O "${temp_dir}/start.elf" "${FIRMWARE_URL}/start.elf"
35 35 as_nobody wget -q -O "${temp_dir}/start_cd.elf" "${FIRMWARE_URL}/start_cd.elf"
36 36 as_nobody wget -q -O "${temp_dir}/start_x.elf" "${FIRMWARE_URL}/start_x.elf"
37 37 as_nobody wget -q -O "${temp_dir}/fixup4cd.dat" "${FIRMWARE_URL}/fixup4cd.dat"
38 38 as_nobody wget -q -O "${temp_dir}/fixup4.dat" "${FIRMWARE_URL}/fixup4.dat"
39 39 as_nobody wget -q -O "${temp_dir}/fixup4db.dat" "${FIRMWARE_URL}/fixup4db.dat"
40 40 as_nobody wget -q -O "${temp_dir}/fixup4x.dat" "${FIRMWARE_URL}/fixup4x.dat"
41 41 as_nobody wget -q -O "${temp_dir}/start4cd.elf" "${FIRMWARE_URL}/start4cd.elf"
42 42 as_nobody wget -q -O "${temp_dir}/start4db.elf" "${FIRMWARE_URL}/start4db.elf"
43 43 as_nobody wget -q -O "${temp_dir}/start4.elf" "${FIRMWARE_URL}/start4.elf"
44 44 as_nobody wget -q -O "${temp_dir}/start4x.elf" "${FIRMWARE_URL}/start4x.elf"
45 45
46 46 # Move downloaded boot binaries
47 47 mv "${temp_dir}/"* "${BOOT_DIR}/"
48 48
49 49 # Remove temporary directory for boot binaries
50 50 rm -fr "${temp_dir}"
51 51
52 52 # Set permissions of the boot binaries
53 53 chown -R root:root "${BOOT_DIR}"
54 54 chmod -R 600 "${BOOT_DIR}"
55 55 fi
56 56
57 57 # Setup firmware boot cmdline
58 58 if [ "$ENABLE_USBBOOT" = true ] ; then
59 59 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
60 60 else
61 61 if [ "$ENABLE_SPLITFS" = true ] ; then
62 62 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda1 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
63 63 else
64 64 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/mmcblk0p2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
65 65 fi
66 66 fi
67 67
68 68 # Add encrypted root partition to cmdline.txt
69 69 if [ "$ENABLE_CRYPTFS" = true ] ; then
70 70 if [ "$ENABLE_SPLITFS" = true ] ; then
71 71 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda1/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda1:${CRYPTFS_MAPPING}/")
72 72 else
73 73 if [ "$ENABLE_USBBOOT" = true ] ; then
74 74 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda2:${CRYPTFS_MAPPING}/")
75 75 else
76 76 CMDLINE=$(echo "${CMDLINE}" | sed "s/mmcblk0p2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/mmcblk0p2:${CRYPTFS_MAPPING}/")
77 77 fi
78 78 fi
79 79 fi
80 80
81 81 # Enable Kernel messages on standard output
82 82 if [ "$ENABLE_PRINTK" = true ] ; then
83 83 install_readonly files/sysctl.d/83-rpi-printk.conf "${ETC_DIR}/sysctl.d/83-rpi-printk.conf"
84 84 fi
85 85
86 86 # Enable Kernel messages on standard output
87 87 if [ "$KERNEL_SECURITY" = true ] ; then
88 88 install_readonly files/sysctl.d/84-rpi-ASLR.conf "${ETC_DIR}/sysctl.d/84-rpi-ASLR.conf"
89 89 fi
90 90
91 91 # Install udev rule for serial alias - serial0 = console serial1=bluetooth
92 92 install_readonly files/etc/99-com.rules "${LIB_DIR}/udev/rules.d/99-com.rules"
93 93
94 94 # Remove IPv6 networking support
95 95 if [ "$ENABLE_IPV6" = false ] ; then
96 96 CMDLINE="${CMDLINE} ipv6.disable=1"
97 97 fi
98 98
99 99 # Automatically assign predictable network interface names
100 100 if [ "$ENABLE_IFNAMES" = false ] ; then
101 101 CMDLINE="${CMDLINE} net.ifnames=0"
102 102 else
103 103 CMDLINE="${CMDLINE} net.ifnames=1"
104 104 fi
105 105
106 106 # Disable Raspberry Pi console logo
107 107 if [ "$ENABLE_LOGO" = false ] ; then
108 108 CMDLINE="${CMDLINE} logo.nologo"
109 109 fi
110 110
111 111 # Strictly limit verbosity of boot up console messages
112 112 if [ "$ENABLE_SILENT_BOOT" = true ] ; then
113 113 CMDLINE="${CMDLINE} quiet loglevel=0 rd.systemd.show_status=auto rd.udev.log_priority=0"
114 114 fi
115 115
116 116 # Install firmware config
117 117 install_readonly files/boot/config.txt "${BOOT_DIR}/config.txt"
118 118
119 119 # Disable Raspberry Pi console logo
120 120 if [ "$ENABLE_SPLASH" = false ] ; then
121 121 echo "disable_splash=1" >> "${BOOT_DIR}/config.txt"
122 122 fi
123 123
124 124 # Locks CPU frequency at maximum
125 125 if [ "$ENABLE_TURBO" = true ] ; then
126 126 echo "force_turbo=1" >> "${BOOT_DIR}/config.txt"
127 127 # helps to avoid sdcard corruption when force_turbo is enabled.
128 128 echo "boot_delay=1" >> "${BOOT_DIR}/config.txt"
129 129 fi
130 130
131 131 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ]; then
132 132
133 133 # Bluetooth enabled
134 134 if [ "$ENABLE_BLUETOOTH" = true ] ; then
135 135 # Create temporary directory for Bluetooth sources
136 136 temp_dir=$(as_nobody mktemp -d)
137 137
138 138 # Fetch Bluetooth sources
139 139 as_nobody git -C "${temp_dir}" clone "${BLUETOOTH_URL}"
140 140
141 141 # Copy downloaded sources
142 142 mv "${temp_dir}/pi-bluetooth" "${R}/tmp/"
143 143
144 144 # Set permissions
145 145 chown -R root:root "${R}/tmp/pi-bluetooth"
146 146
147 147 # Bluetooth firmware from arch aur https://aur.archlinux.org/packages/pi-bluetooth/
148 148 wget -q -O "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" https://aur.archlinux.org/cgit/aur.git/plain/LICENCE.broadcom_bcm43xx?h=pi-bluetooth
149 149 wget -q -O "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" https://raw.githubusercontent.com/RPi-Distro/bluez-firmware/master/broadcom/BCM43430A1.hcd
150 150
151 151 # Install tools
152 152 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/btuart" "${R}/usr/bin/btuart"
153 153 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/bthelper" "${R}/usr/bin/bthelper"
154 154
155 155 # make scripts executable
156 156 chmod +x "${R}/usr/bin/bthelper"
157 157 chmod +x "${R}/usr/bin/btuart"
158 158
159 159 # Install bluetooth udev rule
160 160 install_readonly "${R}/tmp/pi-bluetooth/lib/udev/rules.d/90-pi-bluetooth.rules" "${LIB_DIR}/udev/rules.d/90-pi-bluetooth.rules"
161 161
162 162 # Install Firmware Flash file and apropiate licence
163 163 mkdir -p "$BLUETOOTH_FIRMWARE_DIR"
164 164 install_readonly "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
165 165 install_readonly "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" "${BLUETOOTH_FIRMWARE_DIR}/BCM43430A1.hcd"
166 166 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.bthelper@.service" "${ETC_DIR}/systemd/system/pi-bluetooth.bthelper@.service"
167 167 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.hciuart.service" "${ETC_DIR}/systemd/system/pi-bluetooth.hciuart.service"
168 168
169 169 # Remove temporary directories
170 170 rm -fr "${temp_dir}"
171 171 rm -fr "${R}"/tmp/pi-bluetooth
172 172
173 173 # Switch Pi3 Bluetooth function to use the mini-UART (ttyS0) and restore UART0/ttyAMA0 over GPIOs 14 & 15. Slow Bluetooth and slow cpu. Use /dev/ttyS0 instead of /dev/ttyAMA0
174 174 if [ "$ENABLE_MINIUART_OVERLAY" = true ] ; then
175 175 # set overlay to swap ttyAMA0 and ttyS0
176 176 echo "dtoverlay=pi3-miniuart-bt" >> "${BOOT_DIR}/config.txt"
177 177
178 178 if [ "$ENABLE_TURBO" = false ] ; then
179 179 echo "core_freq=250" >> "${BOOT_DIR}/config.txt"
180 180 fi
181 181
182 182 fi
183 183
184 184 # Activate services
185 185 chroot_exec systemctl enable pi-bluetooth.hciuart.service
186 186
187 187 else # if ENABLE_BLUETOOTH = false
188 188 # set overlay to disable bluetooth
189 189 echo "dtoverlay=pi3-disable-bt" >> "${BOOT_DIR}/config.txt"
190 190 fi # ENABLE_BLUETOOTH end
191 191 fi
192 192
193 193 # may need sudo systemctl disable hciuart
194 194 if [ "$ENABLE_CONSOLE" = true ] ; then
195 195 echo "enable_uart=1" >> "${BOOT_DIR}/config.txt"
196 196 #More debug output on early but with serial console
197 197 echo "uart_2ndstage=1" >> "${BOOT_DIR}/config.txt"
198 198
199 199 # add string to cmdline
200 200 CMDLINE="${CMDLINE} console=serial0,115200"
201 201
202 202 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]|| [ "$RPI_MODEL" = 0 ]; then
203 203 # if force_turbo didn't lock cpu at high speed, lock it at low speed (XOR logic) or miniuart will be broken
204 204 if [ "$ENABLE_TURBO" = false ] ; then
205 205 echo "core_freq=250" >> "${BOOT_DIR}/config.txt"
206 206 fi
207 207 fi
208 208
209 209 # Enable serial console systemd style
210 210 chroot_exec systemctl enable serial-getty@serial0.service
211 211 else
212 212 echo "enable_uart=0" >> "${BOOT_DIR}/config.txt"
213 213 fi
214 214
215 215 # Disable dphys-swapfile service. Will get enabled on first boot
216 216 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
217 217 chroot_exec systemctl disable dphys-swapfile
218 218 fi
219 219
220 220 if [ "$ENABLE_SYSTEMDSWAP" = true ] ; then
221 221 # Create temporary directory for systemd-swap sources
222 222 temp_dir=$(as_nobody mktemp -d)
223 223
224 224 # Fetch systemd-swap sources
225 225 as_nobody git -C "${temp_dir}" clone "${SYSTEMDSWAP_URL}"
226 226
227 227 # Copy downloaded systemd-swap sources
228 228 mv "${temp_dir}/systemd-swap" "${R}/tmp/"
229 229
230 230 # Change into downloaded src dir
231 231 cd "${R}/tmp/systemd-swap" || exit
232 232
233 233 # Get Verion
234 234 VERSION=$(git tag | tail -n 1)
235 235 #sed -i "s/DEB_NAME=.*/DEB_NAME=systemd-swap_all/g" "${R}/tmp/systemd-swap/package.sh"
236 236
237 237 # Build package
238 238 bash ./package.sh debian
239 239
240 240 # Change back into script root dir
241 241 cd "${WORKDIR}" || exit
242 242
243 243 # Set permissions of the systemd-swap sources
244 244 chown -R root:root "${R}/tmp/systemd-swap"
245 245
246 246 # Install package - IMPROVE AND MAKE IT POSSIBLE WITHOUT VERSION NR.
247 247 chroot_exec dpkg -i /tmp/systemd-swap/systemd-swap_"$VERSION"_all.deb
248 248
249 249 # Enable service
250 250 chroot_exec systemctl enable systemd-swap
251 251
252 252 # Remove temporary directory for systemd-swap sources
253 253 rm -fr "${temp_dir}"
254 254 else
255 255 # Enable ZSWAP in cmdline if systemd-swap is not used
256 256 if [ "$KERNEL_ZSWAP" = true ] ; then
257 257 CMDLINE="${CMDLINE} zswap.enabled=1 zswap.max_pool_percent=25 zswap.compressor=lz4"
258 258 fi
259 259 fi
260 260 if [ "$KERNEL_SECURITY" = true ] ; then
261 261 CMDLINE="${CMDLINE} apparmor=1 security=apparmor"
262 262 fi
263 263
264 264 # Install firmware boot cmdline
265 265 echo "${CMDLINE}" > "${BOOT_DIR}/cmdline.txt"
266 266
267 267 # Setup minimal GPU memory allocation size: 16MB (no X)
268 if [ "$ENABLE_MINGPU" = true ] ; then
268 if [ "$ENABLE_MINGPU" = true ] && [ "$ENABLE_GR_ACCEL" = false ] ; then
269 269 echo "gpu_mem=16" >> "${BOOT_DIR}/config.txt"
270 270 fi
271 271
272 272 # Setup boot with initramfs
273 273 if [ "$ENABLE_INITRAMFS" = true ] ; then
274 274 echo "initramfs initramfs-${KERNEL_VERSION} followkernel" >> "${BOOT_DIR}/config.txt"
275 275 fi
276 276
277 277 # Create firmware configuration and cmdline symlinks
278 278 ln -sf firmware/config.txt "${R}/boot/config.txt"
279 279 ln -sf firmware/cmdline.txt "${R}/boot/cmdline.txt"
280 280
281 281 # Install and setup kernel modules to load at boot
282 282 mkdir -p "${LIB_DIR}/modules-load.d/"
283 283 install_readonly files/modules/rpi2.conf "${LIB_DIR}/modules-load.d/rpi2.conf"
284 284
285 285 # Load hardware random module at boot
286 286 if [ "$ENABLE_HWRANDOM" = true ] && [ "$BUILD_KERNEL" = false ] ; then
287 287 sed -i "s/^# bcm2708_rng/bcm2708_rng/" "${LIB_DIR}/modules-load.d/rpi2.conf"
288 288 fi
289 289
290 290 # Load sound module at boot
291 291 if [ "$ENABLE_SOUND" = true ] ; then
292 292 sed -i "s/^# snd_bcm2835/snd_bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
293 293 else
294 294 echo "dtparam=audio=off" >> "${BOOT_DIR}/config.txt"
295 295 fi
296 296
297 297 # Enable I2C interface
298 298 if [ "$ENABLE_I2C" = true ] ; then
299 299 echo "dtparam=i2c_arm=on" >> "${BOOT_DIR}/config.txt"
300 300 sed -i "s/^# i2c-bcm2708/i2c-bcm2708/" "${LIB_DIR}/modules-load.d/rpi2.conf"
301 301 sed -i "s/^# i2c-dev/i2c-dev/" "${LIB_DIR}/modules-load.d/rpi2.conf"
302 302 fi
303 303
304 304 # Enable SPI interface
305 305 if [ "$ENABLE_SPI" = true ] ; then
306 306 echo "dtparam=spi=on" >> "${BOOT_DIR}/config.txt"
307 307 echo "spi-bcm2708" >> "${LIB_DIR}/modules-load.d/rpi2.conf"
308 308 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]; then
309 309 sed -i "s/spi-bcm2708/spi-bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
310 310 fi
311 311 fi
312 312
313 #Enable graphics acceleration for Model 4
314 if [ "$RPI_MODEL" = 4 ] && [ "$ENABLE_GR_ACCEL" = true ] ; then
315 echo "max_framebuffers=2" >> "${BOOT_DIR}/config.txt"
316 echo "arm_64bit=1" >> "${BOOT_DIR}/config.txt"
317 echo "cmdline=cmdline.txt" >> "${BOOT_DIR}/config.txt"
318 echo "dtparam=audio=on" >> "${BOOT_DIR}/config.txt"
319 echo "gpu_mem=128" >> "${BOOT_DIR}/config.txt"
320 echo "dtoverlay=vc4-fkms-v3d, cma-128" >> "${BOOT_DIR}/config.txt"
321 fi
322
323
313 324 # Disable RPi2/3 under-voltage warnings
314 325 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
315 326 echo "avoid_warnings=${DISABLE_UNDERVOLT_WARNINGS}" >> "${BOOT_DIR}/config.txt"
316 327 fi
317 328
318 329 # Install kernel modules blacklist
319 330 mkdir -p "${ETC_DIR}/modprobe.d/"
320 331 install_readonly files/modules/raspi-blacklist.conf "${ETC_DIR}/modprobe.d/raspi-blacklist.conf"
321 332
322 333 # Install sysctl.d configuration files
323 334 install_readonly files/sysctl.d/81-rpi-vm.conf "${ETC_DIR}/sysctl.d/81-rpi-vm.conf"
@@ -1,922 +1,923
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=3P}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47 if [ $RELEASE = "bullseye" ] ; then
48 48 RELEASE=testing
49 49 fi
50 50
51 51 # Kernel Branch
52 52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53 53
54 54 # URLs
55 55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
58 58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
59 59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
60 60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
61 61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
62 62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
63 63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
64 64
65 65 # Kernel deb packages for 32bit kernel
66 66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
67 67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
68 68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
69 69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.102.20200211/bcmrpi3-kernel-bis-4.19.102.20200211.tar.xz}
70 70 # Default precompiled 64bit kernel
71 71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.102.20200211/bcmrpi3-kernel-4.19.102.20200211.tar.xz}
72 72 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
73 73 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
74 74 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
75 75 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
76 76 # Generic
77 77 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
78 78 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
79 79 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
80 80 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
81 81
82 82 # Build directories
83 83 WORKDIR=$(pwd)
84 84 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
85 85 BUILDDIR="${BASEDIR}/build"
86 86
87 87 # Chroot directories
88 88 R="${BUILDDIR}/chroot"
89 89 ETC_DIR="${R}/etc"
90 90 LIB_DIR="${R}/lib"
91 91 BOOT_DIR="${R}/boot/firmware"
92 92 KERNEL_DIR="${R}/usr/src/linux"
93 93 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
94 94 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
95 95
96 96 # APT settings
97 97 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
98 98 APT_PROXY=${APT_PROXY:=""}
99 99 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
100 100 # Packages required in the chroot build environment
101 101 APT_INCLUDES=${APT_INCLUDES:=""}
102 102 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
103 103 # Packages to exclude from chroot build environment
104 104 APT_EXCLUDES=${APT_EXCLUDES:=""}
105 105
106 106 # General settings
107 107 SET_ARCH=${SET_ARCH:=32}
108 108 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
109 109 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
110 110 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
111 111 EXPANDROOT=${EXPANDROOT:=true}
112 112
113 113 ENABLE_ROOT=${ENABLE_ROOT:=false}
114 114 ROOT_PASSWORD=${ROOT_PASSWORD:=raspberry}
115 115 ENABLE_USER=${ENABLE_USER:=true}
116 116 USER_NAME=${USER_NAME:="pi"}
117 117 USER_PASSWORD=${USER_PASSWORD:=raspberry}
118 118
119 119 # Keyboard settings
120 120 XKB_MODEL=${XKB_MODEL:=""}
121 121 XKB_LAYOUT=${XKB_LAYOUT:=""}
122 122 XKB_VARIANT=${XKB_VARIANT:=""}
123 123 XKB_OPTIONS=${XKB_OPTIONS:=""}
124 124
125 125 # Networking settings:
126 126 ENABLE_IPV6=${ENABLE_IPV6:=true}
127 127 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
128 128 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
129 129 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
130 130 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
131 131
132 132 # Network settings (DHCP)
133 133 ENABLE_ETH_DHCP=${ENABLE_ETH_DHCP:=true}
134 134 ENABLE_WIFI_DHCP=${ENABLE_ETH_DHCP:=true}
135 135
136 136 # Network settings (static)
137 137 NET_ETH_ADDRESS=${NET_ETH_ADDRESS:=""}
138 138 NET_ETH_GATEWAY=${NET_ETH_GATEWAY:=""}
139 139 NET_ETH_DNS_1=${NET_ETH_DNS_1:=""}
140 140 NET_ETH_DNS_2=${NET_ETH_DNS_2:=""}
141 141 NET_ETH_DNS_DOMAINS=${NET_ETH_DNS_DOMAINS:=""}
142 142 NET_ETH_NTP_1=${NET_ETH_NTP_1:=""}
143 143 NET_ETH_NTP_2=${NET_ETH_NTP_2:=""}
144 144
145 145 # Networking settings (WIFI):
146 146 NET_WIFI_SSID=${NET_WIFI_SSID:=""}
147 147 NET_WIFI_PSK=${NET_WIFI_PSK:=""}
148 148
149 149 # Network settings (static)
150 150 NET_WIFI_ADDRESS=${NET_WIFI_ADDRESS:=""}
151 151 NET_WIFI_GATEWAY=${NET_WIFI_GATEWAY:=""}
152 152 NET_WIFI_DNS_1=${NET_WIFI_DNS_1:=""}
153 153 NET_WIFI_DNS_2=${NET_WIFI_DNS_2:=""}
154 154 NET_WIFI_DNS_DOMAINS=${NET_WIFI_DNS_DOMAINS:=""}
155 155 NET_WIFI_NTP_1=${NET_WIFI_NTP_1:=""}
156 156 NET_WIFI_NTP_2=${NET_WIFI_NTP_2:=""}
157 157
158 158 # Feature settings
159 159 ENABLE_CONSOLE=${ENABLE_CONSOLE:=false}
160 160 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
161 161 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
162 162 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
163 163 ENABLE_TURBO=${ENABLE_TURBO:=false}
164 164 ENABLE_I2C=${ENABLE_I2C:=false}
165 165 ENABLE_SPI=${ENABLE_SPI:=false}
166 166
167 167 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
168 168 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
169 169 ENABLE_SOUND=${ENABLE_SOUND:=false}
170 170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 172 ENABLE_XORG=${ENABLE_XORG:=false}
173 173 ENABLE_WM=${ENABLE_WM:=""}
174 174 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
175 175 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
176 176 ENABLE_LOGO=${ENABLE_LOGO:=true}
177 177 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
178 178 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
179 179
180 180 # Advanced settings
181 181 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
182 182 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
183 183 ENABLE_QEMU=${ENABLE_QEMU:=false}
184 184 ENABLE_KEYGEN=${ENABLE_KEYGEN:=false}
185 185 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
186 186 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
187 187 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
188 188 ENABLE_DBUS=${ENABLE_DBUS:=true}
189 189 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
190 190 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
191 191 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
192 192 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
193 193 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
194 ENABLE_GR_ACCEL=$ENABLE_GR_ACCEL:=true}
194 195 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
195 196 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
196 197 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
197 198 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
198 199 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
199 200
200 201 # SSH settings
201 202 SSH_ENABLE=${SSH_ENABLE:=true}
202 203 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
203 204 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
204 205 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
205 206 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
206 207 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
207 208
208 209 # Kernel compilation settings
209 210 BUILD_KERNEL=${BUILD_KERNEL:=true}
210 211 KERNEL_THREADS=${KERNEL_THREADS:=1}
211 212 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
212 213 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
213 214 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
214 215 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
215 216 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
216 217 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
217 218 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
218 219 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
219 220 KERNELSRC_USRCONFIG=${KERNELSRC_USRCONFIG:=""}
220 221 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
221 222 # Firmware directory: Blank if download from github
222 223 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
223 224 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
224 225 KERNEL_NF=${KERNEL_NF:=false}
225 226 KERNEL_VIRT=${KERNEL_VIRT:=false}
226 227 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
227 228 KERNEL_BPF=${KERNEL_BPF:=false}
228 229 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
229 230 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
230 231 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
231 232 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
232 233 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
233 234
234 235 # Reduce disk usage settings
235 236 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
236 237 REDUCE_APT=${REDUCE_APT:=true}
237 238 REDUCE_DOC=${REDUCE_DOC:=false}
238 239 REDUCE_MAN=${REDUCE_MAN:=false}
239 240 REDUCE_VIM=${REDUCE_VIM:=false}
240 241 REDUCE_BASH=${REDUCE_BASH:=false}
241 242 REDUCE_HWDB=${REDUCE_HWDB:=false}
242 243 REDUCE_SSHD=${REDUCE_SSHD:=false}
243 244 REDUCE_LOCALE=${REDUCE_LOCALE:=false}
244 245 REDUCE_KERNEL=${REDUCE_KERNEL:=false}
245 246
246 247 # Encrypted filesystem settings
247 248 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
248 249 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
249 250 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
250 251 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
251 252 CRYPTFS_HASH=${CRYPTFS_HASH:="sha256"}
252 253 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=256}
253 254 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
254 255 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
255 256 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
256 257 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
257 258
258 259 # Packages required for bootstrapping
259 260 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
260 261 MISSING_PACKAGES=""
261 262
262 263 # Packages installed for c/c++ build environment in chroot (keep empty)
263 264 COMPILER_PACKAGES=""
264 265
265 266 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
266 267 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
267 268 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
268 269 APT_PROXY=http://127.0.0.1:3142/
269 270 fi
270 271
271 272 # Setup architecture specific settings
272 273 if [ -n "$SET_ARCH" ] ; then
273 274 ## 64-bit configuration
274 275 if [ "$SET_ARCH" = 64 ] ; then
275 276 ### General 64-bit depended settings
276 277 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
277 278 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
278 279 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
279 280
280 281 ### Raspberry Pi 64-bit model specific settings
281 282 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
282 283 if [ "$RPI_MODEL" != 4 ] ; then
283 284 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
284 285 else
285 286 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
286 287 fi
287 288
288 289 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
289 290 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
290 291 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
291 292 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
292 293
293 294 else
294 295 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
295 296 exit 1
296 297 fi
297 298 fi
298 299
299 300 ## 32-bit configuration
300 301 if [ "$SET_ARCH" = 32 ] ; then
301 302 ### General 32-bit dependend settings
302 303 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
303 304 KERNEL_ARCH=${KERNEL_ARCH:=arm}
304 305 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
305 306
306 307 ### Raspberry Pi (0-1P) model specific settings
307 308 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
308 309 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
309 310 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
310 311 RELEASE_ARCH=${RELEASE_ARCH:=armel}
311 312 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
312 313 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
313 314 if [ $ENABLE_XORG = true ] ; then
314 315 if [$RELEASE = "stretch" ] || [$RELEASE = "oldstable" ] ; then
315 316 printf "\nBest support for armel architecture is provided under Debian stretch/oldstable. Choose yes to change release to Debian stretch[y/n] "
316 317 read -r confirm
317 318 if [ "$confirm" = "y" ] ; then
318 319 $RELEASE = "stretch"
319 320 fi
320 321 fi
321 322 fi
322 323 fi
323 324 ### Raspberry Pi (2-4) model specific settings
324 325 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
325 326 if [ "$RPI_MODEL" != 4 ] ; then
326 327 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
327 328 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
328 329 else
329 330 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
330 331 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
331 332 fi
332 333
333 334 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
334 335 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
335 336
336 337 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
337 338 fi
338 339 fi
339 340
340 341 # SET_ARCH not set
341 342 else
342 343 echo "error: Please set '32' or '64' as value for SET_ARCH"
343 344 exit 1
344 345 fi
345 346 # Device specific configuration and U-Boot configuration
346 347 case "$RPI_MODEL" in
347 348 0)
348 349 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
349 350 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
350 351 ;;
351 352 1)
352 353 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
353 354 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
354 355 ;;
355 356 1P)
356 357 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
357 358 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
358 359 ;;
359 360 2)
360 361 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
361 362 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
362 363 ;;
363 364 3)
364 365 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
365 366 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
366 367 ;;
367 368 3P)
368 369 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
369 370 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
370 371 ;;
371 372 4)
372 373 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
373 374 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
374 375 ;;
375 376 *)
376 377 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
377 378 exit 1
378 379 ;;
379 380 esac
380 381
381 382 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
382 383 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
383 384 ## Include bluetooth packages on supported boards
384 385 if [ "$ENABLE_BLUETOOTH" = true ] ; then
385 386 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
386 387 fi
387 388 if [ "$ENABLE_WIRELESS" = true ] ; then
388 389 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,wpasupplicant"
389 390 fi
390 391 # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
391 392 else
392 393 ## Check if the internal wireless interface is not supported by the RPi model
393 394 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
394 395 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
395 396 exit 1
396 397 fi
397 398 fi
398 399
399 400 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
400 401 echo "error: You have to compile kernel sources, if you want to enable nexmon"
401 402 exit 1
402 403 fi
403 404
404 405 # Prepare date string for default image file name
405 406 DATE="$(date +%Y-%m-%d)"
406 407 if [ -z "$KERNEL_BRANCH" ] ; then
407 408 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
408 409 else
409 410 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
410 411 fi
411 412
412 413 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
413 414 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
414 415 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
415 416 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
416 417 exit 1
417 418 fi
418 419 fi
419 420
420 421 # Add cmake to compile videocore sources
421 422 if [ "$ENABLE_VIDEOCORE" = true ] ; then
422 423 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
423 424 fi
424 425
425 426 # Add deps for nexmon
426 427 if [ "$ENABLE_NEXMON" = true ] ; then
427 428 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
428 429 fi
429 430
430 431 # Add libncurses5 to enable kernel menuconfig
431 432 if [ "$KERNEL_MENUCONFIG" = true ] ; then
432 433 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
433 434 fi
434 435
435 436 # Add ccache compiler cache for (faster) kernel cross (re)compilation
436 437 if [ "$KERNEL_CCACHE" = true ] ; then
437 438 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
438 439 fi
439 440
440 441 # Add cryptsetup package to enable filesystem encryption
441 442 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
442 443 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
443 444 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
444 445
445 446 ## If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
446 447 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
447 448 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
448 449 fi
449 450
450 451 if [ -z "$CRYPTFS_PASSWORD" ] ; then
451 452 echo "error: no password defined (CRYPTFS_PASSWORD)!"
452 453 exit 1
453 454 fi
454 455 ENABLE_INITRAMFS=true
455 456 fi
456 457
457 458 # Add initramfs generation tools
458 459 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
459 460 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
460 461 fi
461 462
462 463 # Add device-tree-compiler required for building the U-Boot bootloader
463 464 if [ "$ENABLE_UBOOT" = true ] ; then
464 465 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bc"
465 466 fi
466 467
467 468 if [ "$ENABLE_USBBOOT" = true ] ; then
468 469 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
469 470 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
470 471 exit 1
471 472 fi
472 473 fi
473 474
474 475 # Check if root SSH (v2) public key file exists
475 476 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
476 477 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
477 478 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
478 479 exit 1
479 480 fi
480 481 fi
481 482
482 483 # Check if $USER_NAME SSH (v2) public key file exists
483 484 if [ -n "$SSH_USER_PUB_KEY" ] ; then
484 485 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
485 486 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
486 487 exit 1
487 488 fi
488 489 fi
489 490
490 491 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
491 492 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
492 493 exit 1
493 494 fi
494 495
495 496 # Check if all required packages are installed on the build system
496 497 for package in $REQUIRED_PACKAGES ; do
497 498 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
498 499 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
499 500 fi
500 501 done
501 502
502 503 # If there are missing packages ask confirmation for install, or exit
503 504 if [ -n "$MISSING_PACKAGES" ] ; then
504 505 echo "the following packages needed by this script are not installed:"
505 506 echo "$MISSING_PACKAGES"
506 507
507 508 printf "\ndo you want to install the missing packages right now? [y/n] "
508 509 read -r confirm
509 510 [ "$confirm" != "y" ] && exit 1
510 511
511 512 ## Make sure all missing required packages are installed
512 513 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
513 514 fi
514 515
515 516 # Check if ./bootstrap.d directory exists
516 517 if [ ! -d "./bootstrap.d/" ] ; then
517 518 echo "error: './bootstrap.d' required directory not found!"
518 519 exit 1
519 520 fi
520 521
521 522 # Check if ./files directory exists
522 523 if [ ! -d "./files/" ] ; then
523 524 echo "error: './files' required directory not found!"
524 525 exit 1
525 526 fi
526 527
527 528 # Check if specified KERNELSRC_DIR directory exists
528 529 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
529 530 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
530 531 exit 1
531 532 fi
532 533
533 534 # Check if specified UBOOTSRC_DIR directory exists
534 535 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
535 536 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
536 537 exit 1
537 538 fi
538 539
539 540 # Check if specified VIDEOCORESRC_DIR directory exists
540 541 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
541 542 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
542 543 exit 1
543 544 fi
544 545
545 546 # Check if specified FBTURBOSRC_DIR directory exists
546 547 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
547 548 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
548 549 exit 1
549 550 fi
550 551
551 552 # Check if specified NEXMONSRC_DIR directory exists
552 553 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
553 554 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
554 555 exit 1
555 556 fi
556 557
557 558 # Check if specified CHROOT_SCRIPTS directory exists
558 559 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
559 560 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
560 561 exit 1
561 562 fi
562 563
563 564 # Check if specified device mapping already exists (will be used by cryptsetup)
564 565 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
565 566 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
566 567 exit 1
567 568 fi
568 569
569 570 # Don't clobber an old build
570 571 if [ -e "$BUILDDIR" ] ; then
571 572 echo "error: directory ${BUILDDIR} already exists, not proceeding"
572 573 exit 1
573 574 fi
574 575
575 576 # Setup chroot directory
576 577 mkdir -p "${R}"
577 578
578 579 # Check if build directory has enough of free disk space >512MB
579 580 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
580 581 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
581 582 exit 1
582 583 fi
583 584
584 585 set -x
585 586
586 587 # Call "cleanup" function on various signals and errors
587 588 trap cleanup 0 1 2 3 6
588 589
589 590 # Add required packages for the minbase installation
590 591 if [ "$ENABLE_MINBASE" = true ] ; then
591 592 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
592 593 fi
593 594
594 595 # Add parted package, required to get partprobe utility
595 596 if [ "$EXPANDROOT" = true ] ; then
596 597 APT_INCLUDES="${APT_INCLUDES},parted"
597 598 fi
598 599
599 600 # Add dphys-swapfile package, required to enable swap
600 601 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
601 602 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
602 603 fi
603 604
604 605 # Add dbus package, recommended if using systemd
605 606 if [ "$ENABLE_DBUS" = true ] ; then
606 607 APT_INCLUDES="${APT_INCLUDES},dbus"
607 608 fi
608 609
609 610 # Add iptables IPv4/IPv6 package
610 611 if [ "$ENABLE_IPTABLES" = true ] ; then
611 612 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
612 613 fi
613 614 # Add apparmor for KERNEL_SECURITY
614 615 if [ "$KERNEL_SECURITY" = true ] ; then
615 616 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
616 617 fi
617 618
618 619 # Add openssh server package
619 620 if [ "$SSH_ENABLE" = true ] ; then
620 621 APT_INCLUDES="${APT_INCLUDES},openssh-server"
621 622 fi
622 623
623 624 # Add alsa-utils package
624 625 if [ "$ENABLE_SOUND" = true ] ; then
625 626 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
626 627 fi
627 628
628 629 # Add rng-tools package
629 630 if [ "$ENABLE_HWRANDOM" = true ] ; then
630 631 APT_INCLUDES="${APT_INCLUDES},rng-tools"
631 632 fi
632 633
633 634 # Add fbturbo video driver
634 635 if [ "$ENABLE_FBTURBO" = true ] ; then
635 636 # Enable xorg package dependencies
636 637 ENABLE_XORG=true
637 638 fi
638 639
639 640 # Add user defined window manager package
640 641 if [ -n "$ENABLE_WM" ] ; then
641 642 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
642 643
643 644 # Enable xorg package dependencies
644 645 ENABLE_XORG=true
645 646 fi
646 647
647 648 # Add xorg package
648 649 if [ "$ENABLE_XORG" = true ] ; then
649 650 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
650 651 fi
651 652
652 653 # Replace selected packages with smaller clones
653 654 if [ "$ENABLE_REDUCE" = true ] ; then
654 655 ## Add levee package instead of vim-tiny
655 656 if [ "$REDUCE_VIM" = true ] ; then
656 657 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
657 658 fi
658 659
659 660 ## Add dropbear package instead of openssh-server
660 661 if [ "$REDUCE_SSHD" = true ] ; then
661 662 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
662 663 fi
663 664 fi
664 665
665 666 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
666 667 if [ "$ENABLE_SYSVINIT" = false ] ; then
667 668 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
668 669 fi
669 670
670 671 # Configure kernel sources if no KERNELSRC_DIR
671 672 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
672 673 KERNELSRC_CONFIG=true
673 674 fi
674 675
675 676 # Configure reduced kernel
676 677 if [ "$KERNEL_REDUCE" = true ] ; then
677 678 KERNELSRC_CONFIG=false
678 679 fi
679 680
680 681 # Configure qemu compatible kernel
681 682 if [ "$ENABLE_QEMU" = true ] ; then
682 683 DTB_FILE=vexpress-v2p-ca15_a7.dtb
683 684 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
684 685 KERNEL_DEFCONFIG="vexpress_defconfig"
685 686 if [ "$KERNEL_MENUCONFIG" = false ] ; then
686 687 KERNEL_OLDDEFCONFIG=true
687 688 fi
688 689 fi
689 690
690 691 # Execute bootstrap scripts
691 692 for SCRIPT in bootstrap.d/*.sh; do
692 693 head -n 3 "$SCRIPT"
693 694 . "$SCRIPT"
694 695 done
695 696
696 697 ## Execute custom bootstrap scripts
697 698 if [ -d "custom.d" ] ; then
698 699 for SCRIPT in custom.d/*.sh; do
699 700 . "$SCRIPT"
700 701 done
701 702 fi
702 703
703 704 # Execute custom scripts inside the chroot
704 705 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
705 706 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
706 707 chroot_exec /bin/bash -x << EOF
707 708 for SCRIPT in /chroot_scripts/* ; do
708 709 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
709 710 $SCRIPT
710 711 fi
711 712 done
712 713 EOF
713 714 rm -rf "${R}/chroot_scripts"
714 715 fi
715 716
716 717 # Remove c/c++ build environment from the chroot
717 718 chroot_remove_cc
718 719
719 720 # Generate required machine-id
720 721 MACHINE_ID=$(dbus-uuidgen)
721 722 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
722 723 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
723 724
724 725 # APT Cleanup
725 726 chroot_exec apt-get -y clean
726 727 chroot_exec apt-get -y autoclean
727 728 chroot_exec apt-get -y autoremove
728 729
729 730 # Unmount mounted filesystems
730 731 umount -l "${R}/proc"
731 732 umount -l "${R}/sys"
732 733
733 734 # Clean up directories
734 735 rm -rf "${R}/run/*"
735 736 rm -rf "${R}/tmp/*"
736 737
737 738 # Clean up APT proxy settings
738 739 if [ "$KEEP_APT_PROXY" = false ] ; then
739 740 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
740 741 fi
741 742
742 743 # Clean up files
743 744 rm -f "${ETC_DIR}/ssh/ssh_host_*"
744 745 rm -f "${ETC_DIR}/dropbear/dropbear_*"
745 746 rm -f "${ETC_DIR}/apt/sources.list.save"
746 747 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
747 748 rm -f "${ETC_DIR}/*-"
748 749 rm -f "${ETC_DIR}/resolv.conf"
749 750 rm -f "${R}/root/.bash_history"
750 751 rm -f "${R}/var/lib/urandom/random-seed"
751 752 rm -f "${R}/initrd.img"
752 753 rm -f "${R}/vmlinuz"
753 754 rm -f "${R}${QEMU_BINARY}"
754 755
755 756 if [ "$ENABLE_QEMU" = true ] ; then
756 757 # Setup QEMU directory
757 758 mkdir "${BASEDIR}/qemu"
758 759
759 760 # Copy kernel image to QEMU directory
760 761 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
761 762
762 763 # Copy kernel config to QEMU directory
763 764 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
764 765
765 766 # Copy kernel dtbs to QEMU directory
766 767 for dtb in "${BOOT_DIR}/"*.dtb ; do
767 768 if [ -f "${dtb}" ] ; then
768 769 install_readonly "${dtb}" "${BASEDIR}/qemu/"
769 770 fi
770 771 done
771 772
772 773 # Copy kernel overlays to QEMU directory
773 774 if [ -d "${BOOT_DIR}/overlays" ] ; then
774 775 # Setup overlays dtbs directory
775 776 mkdir "${BASEDIR}/qemu/overlays"
776 777
777 778 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
778 779 if [ -f "${dtb}" ] ; then
779 780 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
780 781 fi
781 782 done
782 783 fi
783 784
784 785 # Copy u-boot files to QEMU directory
785 786 if [ "$ENABLE_UBOOT" = true ] ; then
786 787 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
787 788 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
788 789 fi
789 790 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
790 791 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
791 792 fi
792 793 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
793 794 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
794 795 fi
795 796 fi
796 797
797 798 # Copy initramfs to QEMU directory
798 799 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
799 800 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
800 801 fi
801 802 fi
802 803
803 804 # Calculate size of the chroot directory in KB
804 805 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
805 806
806 807 # Calculate the amount of needed 512 Byte sectors
807 808 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
808 809 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
809 810 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
810 811
811 812 # The root partition is EXT4
812 813 # This means more space than the actual used space of the chroot is used.
813 814 # As overhead for journaling and reserved blocks 35% are added.
814 815 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
815 816
816 817 # Calculate required image size in 512 Byte sectors
817 818 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
818 819
819 820 # Prepare image file
820 821 if [ "$ENABLE_SPLITFS" = true ] ; then
821 822 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
822 823 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
823 824 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
824 825 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
825 826
826 827 # Write firmware/boot partition tables
827 828 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null << EOM
828 829 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
829 830 EOM
830 831
831 832 # Write root partition table
832 833 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null << EOM
833 834 ${TABLE_SECTORS},${ROOT_SECTORS},83
834 835 EOM
835 836
836 837 # Setup temporary loop devices
837 838 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
838 839 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
839 840 else # ENABLE_SPLITFS=false
840 841 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
841 842 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
842 843
843 844 # Write partition table
844 845 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null << EOM
845 846 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
846 847 ${ROOT_OFFSET},${ROOT_SECTORS},83
847 848 EOM
848 849
849 850 # Setup temporary loop devices
850 851 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
851 852 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
852 853 fi
853 854
854 855 if [ "$ENABLE_CRYPTFS" = true ] ; then
855 856 # Create dummy ext4 fs
856 857 mkfs.ext4 "$ROOT_LOOP"
857 858
858 859 # Setup password keyfile
859 860 touch .password
860 861 chmod 600 .password
861 862 echo -n ${CRYPTFS_PASSWORD} > .password
862 863
863 864 # Initialize encrypted partition
864 865 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
865 866
866 867 # Open encrypted partition and setup mapping
867 868 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
868 869
869 870 # Secure delete password keyfile
870 871 shred -zu .password
871 872
872 873 # Update temporary loop device
873 874 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
874 875
875 876 # Wipe encrypted partition (encryption cipher is used for randomness)
876 877 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
877 878 fi
878 879
879 880 # Build filesystems
880 881 mkfs.vfat "$FRMW_LOOP"
881 882 mkfs.ext4 "$ROOT_LOOP"
882 883
883 884 # Mount the temporary loop devices
884 885 mkdir -p "$BUILDDIR/mount"
885 886 mount "$ROOT_LOOP" "$BUILDDIR/mount"
886 887
887 888 mkdir -p "$BUILDDIR/mount/boot/firmware"
888 889 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
889 890
890 891 # Copy all files from the chroot to the loop device mount point directory
891 892 rsync -a "${R}/" "$BUILDDIR/mount/"
892 893
893 894 # Unmount all temporary loop devices and mount points
894 895 cleanup
895 896
896 897 # Create block map file(s) of image(s)
897 898 if [ "$ENABLE_SPLITFS" = true ] ; then
898 899 # Create block map files for "bmaptool"
899 900 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
900 901 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
901 902
902 903 # Image was successfully created
903 904 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
904 905 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
905 906 else
906 907 # Create block map file for "bmaptool"
907 908 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
908 909
909 910 # Image was successfully created
910 911 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
911 912
912 913 # Create qemu qcow2 image
913 914 if [ "$ENABLE_QEMU" = true ] ; then
914 915 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
915 916 QEMU_SIZE=16G
916 917
917 918 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
918 919 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
919 920
920 921 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
921 922 fi
922 923 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant